<?php

namespace App\Exports\V2\RoadPatrol;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\WithStyles;
use PhpOffice\PhpSpreadsheet\Worksheet\Worksheet;
use Hekmatinasser\Verta\Verta;

use App\Models\RoadPatrol;

class SupervisorCartableExport implements FromView, ShouldAutoSize, WithEvents, WithDrawings, WithStyles
{
    public function __construct($id, $fromDate, $toDate, $province_id, $edare_id)
    {
        $this->id = $id;
        $this->province_id = $province_id;
        $this->edare_id = $edare_id;
        $this->fromDate = $fromDate;
        $this->toDate = $toDate;
    }

    public function view(): View
    {
        $fromDate = $this->fromDate ? $this->fromDate . ' 00:00:00' : null;
        $toDate = $this->toDate ? $this->toDate . ' 23:59:59' : null;

        if (auth()->user()->can('show-road-patrol-supervise-cartable')) {
            $data = RoadPatrol::when($this->id, function($query, $id){
                        return $query->where('id', 'LIKE', '%'. $id . '%');
                    })
                    ->when($this->province_id, function($query, $province_id){
                        return $query->where('province_id', $province_id);
                    })
                    ->when($this->edare_id, function($query, $edare_id){
                        return $query->where('edare_id', $edare_id);
                    })
                    ->when(($fromDate && $toDate), function($query) use($fromDate, $toDate){
                        return $query->whereBetween('start_time', [$fromDate, $toDate]);
                    })
                    ->select('id', 'province_fa', 'edare_name', 'officer_name', 'officer_phone_number', 'officer_plaque', 
                             'created_at', 'start_time', 'end_time', 'status', 'status_fa', 'distance', 'description')
                    ->orderBy('status')
                    ->orderBy('id', 'desc')
                    ->get();

        } elseif (auth()->user()->can('show-road-patrol-supervise-cartable-province')) {
            if (is_null(auth()->user()->province_id)) {
                return response()->json([
                    'message' => 'استانی برای شما در سامانه ثبت نشده است!'
                ], 400);
            }

            $data = RoadPatrol::where('province_id', auth()->user()->id)
                    ->when($this->id, function($query, $id){
                        return $query->where('id', 'LIKE', '%'. $id . '%');
                    })
                    ->when($this->edare_id, function($query, $edare_id){
                        return $query->where('edare_id', $edare_id);
                    })
                    ->when(($fromDate && $toDate), function($query) use($fromDate, $toDate){
                        return $query->whereBetween('start_time', [$fromDate, $toDate]);
                    })
                    ->select('id', 'province_fa', 'edare_name', 'officer_name', 'officer_phone_number', 'officer_plaque', 
                             'created_at', 'start_time', 'end_time', 'status', 'status_fa', 'distance', 'description')
                    ->orderBy('status')
                    ->orderBy('id', 'desc')
                    ->get();                                        
        }

        return view('excel.V2.RoadPatrol.supervisor_cartable', [
            'data' => $data,
            'fromDate' => $fromDate,
            'toDate' => $toDate
        ]);
    }

    /**
     * @return array
    */
    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function (AfterSheet $event) {
                $event->sheet->getDelegate()->setRightToLeft(true);
            },
        ];
    }

    public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('/dist/logo.png'));
        $drawing->setWidth(50);
        $drawing->setHeight(50);
        $drawing->setOffsetX(5);
        $drawing->setOffsetY(5);
        $drawing->setCoordinates('A1');

        $drawing2 = new Drawing();
        $drawing2->setName('Logo');
        $drawing2->setDescription('This is my logo');
        $drawing2->setPath(public_path('/dist/141icon.png'));
        $drawing2->setWidth(50);
        $drawing2->setHeight(50);
        $drawing2->setOffsetX(5);
        $drawing2->setOffsetY(5);
        $drawing2->setCoordinates('B1');
        return [$drawing, $drawing2];
    }

    public function styles(Worksheet $sheet)
    {

        return [
            // Style the first row as bold text.
            'A:BA' =>    [
                'font' => [
                    'name' => 'B Nazanin'
                ]
            ],
        ];

    }
}
